close,1
openr,1,'calipso.July.22.2019.fil'
nfiles=0
readf,1,nfiles
ofiles=strarr(nfiles)
datfil=strarr(nfiles)
dates=strarr(nfiles)
for nf=0,nfiles-1 do begin
blank=''
readf,1,blank
datfil(nf)=blank
result=str_sep(blank,'.')
label=result(0)+'.'+result(1)
ofiles(nf)=label+'_r1_curtain'
dates(nf)=result(1)
endfor

nfiles=n_elements(datfil)

flt_dir='/ships19/aqda/bpierce/FIREX-AQ/'
moddir='FV3GFS_CALIPSO/'
mod_suff='_with_extinction_C192.v8.9.mollweide.vertmix.plumerise.scale.aware.sas.flux.limited.regrid'

for nf=0,nfiles-1 do begin

  ; READ MODEL CURTAIN FILE
  ; READ MODEL CURTAIN FILE
  filen=ofiles(nf)
  print,filen
  filen=filen+mod_suff+'.dat'
  ifile=flt_dir+moddir+filen
  close,20
  openr,20,ifile,/f77
  nspec=0L
  nl=0L
  ntime=0L
  readu,20,nspec,nl,ntime
  time=dblarr(ntime)
  lons=fltarr(ntime)
  lats=fltarr(ntime)
  psfc=fltarr(ntime)
  zsfc=fltarr(ntime)
  pgrid=fltarr(nl,ntime)
  curtain=fltarr(nspec,nl,ntime)
  thcurt=fltarr(nl,ntime)
  zcurt=fltarr(nl,ntime)
  readu,20,time
  readu,20,lons
  readu,20,lats
  readu,20,psfc
  readu,20,zsfc
  readu,20,pgrid
  readu,20,zcurt
  readu,20,curtain
  readu,20,thcurt
  close,20
pgrid=pgrid/100.
;     'co','noy','o3vmr',$
;       0     1      2
;     'ext_cld6hr','emcofire',$
;       3          4
;     'bc1','bc2','oc1','oc2','sulf',$
;       5     6     7     8     9
;     'dust1','dust2','dust3','dust4','dust5',$
;       10      11      12      13      14
;     'seas1','seas2','seas3','seas4','seas5',$
;       15      16      17      18      19
;'ext_sulf',$
;       20
;'ext_dust',$
;       21
;'ext_seas',$
;       22
;'ext_bcoc',$
;       23
;'ext_tot'$
;       24
;
chem=[$
'pressure',$
'temperature',$
'altitude',$
'ext_cld6hr',$
'ext_sulf',$
'ext_dust',$
'ext_seas',$
'ext_bcoc',$
'ext_aerotot'$
]

units=[$
'mb',$
'K',$
'm',$
'm-1',$
'm-1',$
'm-1',$
'm-1',$
'm-1',$
'm-1'$
]
cindex=[$
-999,$
-999,$
-999,$
3,$
20,$
21,$
22,$
23,$
24$
]
nchem=n_elements(chem)
help,chem,units,cindex

yr=strmid(dates(nf),5,4)
mn=strmid(dates(nf),9,2)
dy=strmid(dates(nf),11,2)
label=yr+mn+dy
print,label
id = NCDF_CREATE('/ships19/aqda/bpierce/FIREX-AQ/FV3GFS_CALIPSO/'+dates(nf)+'.fv3gfs.curtain'+mod_suff+'.nc', /CLOBBER)
; Create a new NetCDF file

NCDF_CONTROL, id, /FILL ; Fill the file with default values.
; dimensions
        bottom_top = nl
        flight_second =ntime ;

tmid = NCDF_DIMDEF(id, 'flight_second', flight_second) ; Make dimensions.
tbid = NCDF_DIMDEF(id, 'bottom_top', bottom_top) ; Make dimensions.

; Define variables

tid = NCDF_VARDEF(id, 'time', [tmid], /FLOAT)
NCDF_ATTPUT, id, tid, 'units','gmt_seconds'
NCDF_ATTPUT, id, tid, 'long_name', 'time'

yid = NCDF_VARDEF(id, 'lat', [tmid], /FLOAT)
NCDF_ATTPUT, id, yid, 'units', 'degrees_north'
NCDF_ATTPUT, id, yid, 'long_name', 'Latitude'
NCDF_ATTPUT, id, yid, '_FillValue', -999.0
NCDF_ATTPUT, id, yid, 'valid_range', [-90.0, 90.0]

xid = NCDF_VARDEF(id, 'lon', [tmid], /FLOAT)
NCDF_ATTPUT, id, xid, 'units', 'degrees_east'
NCDF_ATTPUT, id, xid, 'long_name', 'Longitude'
NCDF_ATTPUT, id, xid, '_FillValue', -999.0
NCDF_ATTPUT, id, xid, 'valid_range', [0.0, 360.0]

zid = NCDF_VARDEF(id, 'zsfc', [tmid], /FLOAT)
NCDF_ATTPUT, id, xid, 'units', 'meters'
NCDF_ATTPUT, id, xid, 'long_name', 'Surface_Height'
NCDF_ATTPUT, id, xid, '_FillValue', -999.0
NCDF_ATTPUT, id, xid, 'valid_range', [0.0, 5000.0]

;
; define 2D variables
;
id3d=fltarr(nchem)
for n=0,nchem-1 do begin
id3d(n) = NCDF_VARDEF(id, chem(n), [tbid,tmid], /FLOAT)
NCDF_ATTPUT, id, id3d(n), 'units', units(n)
NCDF_ATTPUT, id, id3d(n), 'long_name', chem(n)
NCDF_ATTPUT, id, id3d(n), 'coordinates', 'lev time'
NCDF_ATTPUT, id, id3d(n), '_FillValue', -999.0
NCDF_ATTPUT, id, id3d(n), 'missing_value', -999.0
endfor

; global attributes_
NCDF_ATTPUT, id, /GLOBAL, 'TITLE', 'FV3GFS/GOCART Curtain 0.5x0.5 Remapped C196 Forecast'
NCDF_ATTPUT, id, /GLOBAL, 'INSTITUTE', 'SSEC'
NCDF_ATTPUT, id, /GLOBAL, 'FLIGHT_DATE', label
NCDF_ATTPUT, id, /GLOBAL, 'NWP_MODEL', 'OUTPUT FROM FV3GFS/GOCART MODEL'
NCDF_ATTPUT, id, /GLOBAL, 'DELTA_X', 0.5
NCDF_ATTPUT, id, /GLOBAL, 'DELTA_Y', 0.5

NCDF_CONTROL, id, /ENDEF ; Put file in data mode.
;
; put 1D variables
;
NCDF_VARPUT, id, xid, lons
NCDF_VARPUT, id, yid, lats
NCDF_VARPUT, id, zid, zsfc
NCDF_VARPUT, id, tid, time
;
; put 2D variables
;
for n=0,nchem-1 do begin
if n eq 0 then dummy1=pgrid
if n eq 1 then dummy1=thcurt*(pgrid/1000.)^.286
if n eq 2 then dummy1=zcurt
if n ge 3 then dummy1=reform(curtain(cindex(n),*,*),nl,ntime)
print,chem(n),cindex(n),max(dummy1),min(dummy1),units(n)
NCDF_VARPUT, id, id3d(n), dummy1
endfor
NCDF_CLOSE, id ; Close the NetCDF file.
endfor
end 
