; Program to interpolate UW-Hybrid (RAQMS_global) netcdf files
; to flight track. 
;

common exchange,varname
@getpos
@compute_aod_hlut_RAQMS_2d
@compute_aod_CK_RAQMS_2d
curtain_dir='/ships19/aqda/bpierce/FIREX-AQ/FV3GFS_CALIPSO/'
;
; V8.9 with flux limitor on tracer mixing in SSAS and additional variables in regridded files
;
idir='/ships19/aqda/lenzen/FV3GFS.8.9.EXP.ivy.PROD.450/RO3.L384EXP.SSAS.TRPOS.PRCL.NGAC.ZBOC1.T.390/C192/REGRID.0.5/'


datdir='/iliad/proxy/bpierce/Satellite/CALIPSO/'

head='CALIPSO Data'

openr,1,'calipso.July.22.2019.fil'
nfiles=0
readf,1,nfiles
ofiles=strarr(nfiles)
datfil=strarr(nfiles)
for nf=0,nfiles-1 do begin
blank=''
readf,1,blank
;CAL_LID_L2_05kmAPro-Standard-V4-20.2019-07-21T23-36-45ZD.hdf
datfil(nf)=blank
result=str_sep(blank,'.')
label=result(0)+'.'+result(1)
ofiles(nf)=label+'_r1'
endfor
;variable       16bc1FLOAT           4
;variable       17bc2FLOAT           4
;variable       18oc1FLOAT           4
;variable       19oc2FLOAT           4
;variable       20no2FLOAT           4
;variable       21lnoxFLOAT           4
;variable       22potvortFLOAT           4
;variable       23pdashFLOAT           4
;variable       24zdashFLOAT           4
;variable       25coFLOAT           4
;variable       26oxFLOAT           4
;variable       27o3vmrFLOAT           4
;variable       28ch4FLOAT           4
;variable       29ch2oFLOAT           4
;variable       30hno3tFLOAT           4
;variable       31ext_totFLOAT           4
;variable       32ext_bcocFLOAT           4
;variable       33ext_dustFLOAT           4
;variable       34ext_seasFLOAT           4
;variable       35ext_sulfFLOAT           4
;variable       36dust1FLOAT           4
;variable       37dust2FLOAT           4
;variable       38dust3FLOAT           4
;variable       39dust4FLOAT           4
;variable       40dust5FLOAT           4
;variable       41seas1FLOAT           4
;variable       42seas2FLOAT           4
;variable       43seas3FLOAT           4
;variable       44seas4FLOAT           4
;variable       45seas5FLOAT           4
;variable       46o3depFLOAT           3
;variable       47codepFLOAT           3
;variable       48colno2FLOAT           3
;variable       49colnoyFLOAT           3
;variable       50no2tenFLOAT           4
;variable       51lnox2dFLOAT           3
;variable       52jo1dFLOAT           4
;variable       53jnoFLOAT           4
;variable       54cot6hrFLOAT           4
;variable       55emcofireFLOAT           4
;variable       56thetaFLOAT           4
;variable       57sulfFLOAT           4
;variable       58noyFLOAT           4
cname=[$
     'co','noy','o3vmr',$
     'ext_cld6hr','emcofire',$
     'bc1','bc2','oc1','oc2','sulf',$
     'dust1','dust2','dust3','dust4','dust5',$
     'seas1','seas2','seas3','seas4','seas5',$
'ext_sulf',$
'ext_dust',$
'ext_seas',$
'ext_bcoc',$
'ext_tot'$
]

nchem=n_elements(cname)

for nf=0,nfiles-1 do begin
;-------------------------------------------------------------------------
 ; Read in CALIPSO Extinction data
 ;-------------------------------------------------------------------------
close,2
filename=datdir+datfil(nf)
sds_name_APro='Extinction_Coefficient_532'

err=0
err=HDF_OPEN(filename)
if err le 0 then goto,jump_to_end
vdata_ref=-1
vdata_ref=HDF_VD_GETID(err,vdata_ref)
vdata_id=HDF_VD_ATTACH(err,vdata_ref,/READ)
result=HDF_VD_READ(vdata_id,Altitude,fields="Lidar_Data_Altitudes")
if result eq 0 then stop, result

FileID=HDF_SD_START(filename,/READ)

index=HDF_SD_NAMETOINDEX(FileID, SDS_NAME_APro)
if index[0] eq -1 then goto,skip_data

; Select the Gridded Data SDS
thisSDSID=HDF_SD_SELECT(FileID, index)
HDF_SD_GETDATA,thisSdsID,data
skip_data:

; Find the index of the 'Profile_UTC_Time' SDS.
index=HDF_SD_NAMETOINDEX(FileID, "Profile_UTC_Time")
thisSDSID=HDF_SD_SELECT(FileID, index)
HDF_SD_GETDATA,thisSdsID,Time

; Find the index of the 'Longitude' SDS.
index=HDF_SD_NAMETOINDEX(FileID, "Longitude")

if index[0] eq -1 then goto,jump_to_end

; Select the Gridded Data SDS
thisSDSID=HDF_SD_SELECT(FileID, index)
HDF_SD_GETDATA,thisSdsID,Longitude

; Find the index of the 'Latitude' SDS.
index=HDF_SD_NAMETOINDEX(FileID, "Latitude")

; Select the Latitude SDS
thisSDSID=HDF_SD_SELECT(FileID, index)
HDF_SD_GETDATA,thisSdsID,Latitude

HDF_SD_ENDACCESS,thisSdsID
HDF_SD_END,FileID
;HDF_CLOSE,err

jump_to_end:
;CAL_LID_L2_05kmAPro-Standard-V4-20.2019-07-21T23-36-45ZD.hdf
  iyear=long(strmid(datfil(nf),35,4))
  imon=long(strmid(datfil(nf),40,2))
  iday=long(strmid(datfil(nf),43,2))
decade=iyear-2000l
;time=reform(time(1,*))-(decade*1000l+imon*100l+iday*10l)
time=reform(time(1,*))
longitude=reform(longitude(1,*))
latitude=reform(latitude(1,*))
nvalues=n_elements(time)
utchr=(time mod 1.)*24.
help,utchr
index=where(utchr-shift(utchr,-1) gt 0.)
if index(0) ne -1 and index(0) ne nvalues-1 then utchr(index(0)+1:nvalues-1)=utchr(index(0)+1:nvalues-1)+24.
nt=n_elements(time)
nz=n_elements(altitude)
nvalues=nt
nlevs=nz; number of levels
Psurface=1000.
Second=utchr*60.*60.
  iyear=long(strmid(datfil(nf),35,4))
  imon=long(strmid(datfil(nf),40,2))
  iday=long(strmid(datfil(nf),43,2))
  utcsec=second
print,utcsec(0),utcsec(nvalues-1)
  flight_start=julday(imon,iday,iyear,0.,0.,utcsec(0))
  flight_stop=julday(imon,iday,iyear,0.,0.,utcsec(nvalues-1))
  daynum=julday(imon,iday,iyear)-julday(1,0,iyear)
  xjday=float(daynum)
  jdaystart=daynum(0)
  daynum2=flight_stop-julday(1,0,iyear)
  jdaystop=round(daynum2)
help,flight_start,flight_stop
help,jdaystart,jdaystop
  caldat,flight_start,mn1,dy1,yr1,hr1,min1,sec1
  time1=float(hr1)+float(min1)/60.+sec1/3600.
  caldat,flight_stop,mn2,dy2,yr2,hr2,min2,sec2
  time2=float(hr2)+float(min2)/60.+sec2/3600.
;Determine how many model files are needed
  hours=[0.,6.,12.,18.,24.]
  test1=where(hours le time1,c1)
  test2=where(hours ge time2,c2)
  nday=jdaystop-jdaystart+1 
  nmodper=1+round(nday)*4-(c1-1)-(c2-1)
  modfiles=strarr(nmodper)
  dynfiles=strarr(nmodper)
  thishour=long(round(hours(test1(c1-1))))
  print,nmodper,' model files needed:'
  uwhyb_time=dblarr(nmodper)
;Build list of model filenames
  for i=0,nmodper-1 do begin
    modtime=julday(1,xjday,iyear,thishour,0,0)
    uwhyb_time(i)=modtime
    caldat,modtime,mn0,dy0,yr0,hr0,min0,sec0
    hh=round(float(hr0)+float(min0)/60.+sec0/3600.)
    syr=strtrim(yr0,2)
    smn=strtrim(mn0,2)
    if strlen(smn) eq 1 then smn='0'+smn
    sdy=strtrim(dy0,2)
    if strlen(sdy) eq 1 then sdy='0'+sdy
    shr=strtrim(hh,2)
    if strlen(shr) eq 1 then shr='0'+shr
; turn on if monthsubdirectories
;goto, nomonthsubdirectories
;Determine path (date subdirectory) to model files
    if hh ge 999 then begin
      dir='20'+strmid(syr,2,2)+smn+sdy+'12/'
      ;if directory doesn't exist, we are in fx period and need to use latest directory
      test=findfile(idir+dir)
      if test(0) eq '' then begin
        test=findfile(idir)
        dirs=where(strpos(test,'19') ge 0)
        test=test(dirs)
        latest=test(n_elements(test)-1)
        dir=latest+'/'
      endif
    endif else begin
      dirtime=julday(1,xjday(0),2019,thishour-24,0,0)
      caldat,dirtime,mn3,dy3,yr3,hr3,min3,sec3
      hh3=round(float(hr3)+float(min3)/60.+sec3/3600.)
      syr3=strtrim(yr3,2)
      smn3=strtrim(mn3,2)
      if strlen(smn3) eq 1 then smn3='0'+smn3
      sdy3=strtrim(dy3,2)
      if strlen(sdy3) eq 1 then sdy3='0'+sdy3
      shr3=strtrim(hh3,2)
      if strlen(shr3) eq 1 then shr3='0'+shr3
      dir='20'+strmid(syr3,2,2)+smn3+sdy3+'12/'
      ;if directory doesn't exist, we are in fx period and need to use latest directory
      test=findfile(idir+dir)
      if test(0) eq '' then begin
        test=findfile(idir)
        dirs=where(strpos(test,'2019') ge 0)
        test=test(dirs)
        latest=test(n_elements(test)-1)
        dir=latest+'/'
      endif
    endelse
; if date subdirectories exist
    modfiles(i)=idir+dir+'tracer.'+syr+smn+sdy+shr+'.nc'
    dynfiles(i)=idir+dir+'dynf.'+syr+smn+sdy+shr+'.nc'
    print,modfiles(i),dynfiles(i)
    thishour=thishour+6L
  endfor
  itotal=nvalues
  isave=intarr(itotal) & jsave=isave & lsave=isave
  xfsave=fltarr(itotal) & yfsave=xfsave & pfsave=xfsave
  xsave=fltarr(itotal) & ysave=fltarr(itotal)
  cocount=itotal
  yco=latitude
  xco=longitude
  psfc_mod=0.*longitude
  zsfc_mod=0.*longitude
  sco=dblarr(itotal)
  for i=0l,nvalues-1l do begin
;    actime=julday(1,xjday(i),2004,xhour(i),xmin(i),xsec(i))
    actime=julday(imon,iday,iyear,0.,0.,utcsec(i))
    sco(i)=actime
  endfor

  index=where(xco le 0.)
  if index(0) ne -1 then xco(index)=360.+xco(index)
;
; interpolate to measurement position
;
  print,' interpolating to measurement position '
  print,' cocount =',cocount 
;
; C192 (0.5 degree) Grid
  nc=720L
  nr=360L
  nl=64L
  alon=0.25+0.5*findgen(nc)
  alat=-89.75+0.5*findgen(nr)
  alon0=alon
  alat0=alat
;
; Need to consider wrap longitude
  salon=shift(alon,-1)
  salon(nc-1)=360.
  salat=shift(alat,-1)
;
; UWNMS grid is uniform lat/lon, so simple space interp.
;
  for n=0L,cocount-1l do begin
;    if n mod 50 eq 0 then print,100.*n/cocount,' Percent done' 
    xp = xco(n)
    yp = yco(n) 

    iloc=where(alon le xp and salon gt xp,cx)
    jloc=where(alat le yp and salat gt yp,cy)
    if cx ne 1 or cy ne 1 then begin
    ;print,'Unable to interpolate'
    isave(n)=-999
    jsave(n)=-999
    xfsave(n)=-999
    yfsave(n)=-999
    endif else begin
    iloc=iloc(0)
    jloc=jloc(0)
    isave(n)=iloc
    jsave(n)=jloc
    xfsave(n)=(xp-alon(iloc))/(salon(iloc)-alon(iloc))
    yfsave(n)=(yp-alat(jloc))/(salat(jloc)-alat(jloc))
    endelse

  endfor  ;n loop

;
;Have position interpolating info, now read uwhyb files and interpolate
; in space and time
;

  curtain=fltarr(nchem,nl,itotal)
  pcurt=fltarr(nl,itotal)
  zcurt=fltarr(nl,itotal)
  thcurt=fltarr(nl,itotal)

  for itime=0,nmodper-1 do begin
    nleft=0 & left=[0L]
    nright=0 & right=[0L]
    if itime lt nmodper-1 then $
     right=where(sco ge uwhyb_time(itime) and $
                sco lt uwhyb_time(itime+1),nright)
    if itime gt 0 then $
     left=where(sco ge uwhyb_time(itime-1) and $
                sco lt uwhyb_time(itime),nleft)
;
    netcdf_file=dynfiles(itime)
    print,' reading from FV3GFS regridded file',netcdf_file
    nc_file_id=ncdf_open(netcdf_file,/nowrite)
glob_info=ncdf_inquire(nc_file_id)
;print,'number of dimensions ',glob_info.ndims
;print,'number of ;variables ',glob_info.nvars
;print,'number of attributes ',glob_info.ngatts

; get dimensions
;
for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq,nc_file_id, idim, name, dim
    print,'dimension ',idim,name,dim
    if name eq 'grid_xt' then nlon=dim
    if name eq 'grid_yt' then nlat=dim
    if name eq 'pfull' then nlev=dim
endfor
;dimension        0bnds           2
;dimension        1time           1
;dimension        2pfull          64
;dimension        3grid_yt         360
;dimension        4grid_xt         720
;dimension        5phalf          65
;
for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
    print,';variable ',ivar,result.name,result.datatype,result.ndims
endfor
;variable        0timeDOUBLE           1
;variable        1pfullDOUBLE           1
;variable        2phalfDOUBLE           1
;variable        3grid_ytDOUBLE           1
;variable        4grid_yt_bndsDOUBLE           2
;variable        5grid_xtDOUBLE           1
;variable        6grid_xt_bndsDOUBLE           2
;variable        7clwmrFLOAT           4
;variable        8delpFLOAT           4
;variable        9delzFLOAT           4
;variable       10nhpresFLOAT           4
;variable       11o3mrFLOAT           4
;variable       12sphumFLOAT           4
;variable       13tempFLOAT           4
;variable       14ucompFLOAT           4
;variable       15vcompFLOAT           4
;variable       16wFLOAT           4
;stop
ncdf_varget,nc_file_id,'grid_xt',geolon0
ncdf_varget,nc_file_id,'grid_yt',geolat0
ncdf_varget,nc_file_id,'nhpres',press
ncdf_varget,nc_file_id,'delp',delp
ncdf_varget,nc_file_id,'delz',delz
ncdf_varget,nc_file_id,'sphum',q
ncdf_varget,nc_file_id,'temp',t
ncdf_varget,nc_file_id,'ucomp',u
ncdf_varget,nc_file_id,'vcomp',v
ncdf_varget,nc_file_id,'w',w
ncdf_varget,nc_file_id,'o3mr',o3mr
;                o3mr:long_name = "ozone mixing ratio" ;
;                o3mr:units = "kg/kg" ;
o3mr=o3mr*28.97/48.
press=press/100.
delp=delp/100.
delp=reverse(delp,3)
delz=reverse(delz,3)
ncdf_close,nc_file_id
    netcdf_file=modfiles(itime)
    print,' reading from FV3GFS regridded file',netcdf_file
    nc_file_id=ncdf_open(netcdf_file,/nowrite)
;
    glob_info=ncdf_inquire(nc_file_id)
;    if itime eq 0 then begin
;    print,'number of dimensions ',glob_info.ndims
;    print,'number of variables ',glob_info.nvars
;    print,'number of attributes ',glob_info.ngatts
;    endif

; get dimensions
;
    for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq,nc_file_id, idim, name, dim
;    if itime eq 0 then print,'dimension ',idim,name,dim
    if name eq 'grid_yt' then nlat=dim
    if name eq 'grid_xt' then nlon=dim
    if name eq 'grid_zt' then nlev=dim
    endfor
;dimension        0bnds           2
;dimension        1time           1
;dimension        2grid_yt         360
;dimension        3grid_xt         720
;dimension        4grid_zt          64
;
    if itime eq 0 then begin
    for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
;    print,'variable ',ivar,result.name,result.datatype,result.ndims
    endfor
    endif
;variable        0timeDOUBLE           1
;variable        1grid_ytDOUBLE           1
;variable        2grid_yt_bndsDOUBLE           2
;variable        3grid_xtDOUBLE           1
;variable        4grid_xt_bndsDOUBLE           2
;variable        5grid_ztDOUBLE           1
;variable        6sfcpFLOAT           3
;variable        7sfczFLOAT           3
;variable        8aodFLOAT           3
;variable        9aod_bcocFLOAT           3
;variable       10aoddustFLOAT           3
;variable       11aodssaltFLOAT           3
;variable       12aodsulfFLOAT           3
;variable       13zlwigrdFLOAT           3
;variable       14precFLOAT           3
;variable       15prelFLOAT           3
;variable       16bc1FLOAT           4
;variable       17bc2FLOAT           4
;variable       18oc1FLOAT           4
;variable       19oc2FLOAT           4
;variable       20no2FLOAT           4
;variable       21lnoxFLOAT           4
;variable       22potvortFLOAT           4
;variable       23pdashFLOAT           4
;variable       24zdashFLOAT           4
;variable       25coFLOAT           4
;variable       26oxFLOAT           4
;variable       27o3vmrFLOAT           4
;variable       28ch4FLOAT           4
;variable       29ch2oFLOAT           4
;variable       30hno3tFLOAT           4
;variable       31ext_totFLOAT           4
;variable       32ext_bcocFLOAT           4
;variable       33ext_dustFLOAT           4
;variable       34ext_seasFLOAT           4
;variable       35ext_sulfFLOAT           4
;variable       36dust1FLOAT           4
;variable       37dust2FLOAT           4
;variable       38dust3FLOAT           4
;variable       39dust4FLOAT           4
;variable       40dust5FLOAT           4
;variable       41seas1FLOAT           4
;variable       42seas2FLOAT           4
;variable       43seas3FLOAT           4
;variable       44seas4FLOAT           4
;variable       45seas5FLOAT           4
;variable       46o3depFLOAT           3
;variable       47codepFLOAT           3
;variable       48colno2FLOAT           3
;variable       49colnoyFLOAT           3
;variable       50no2tenFLOAT           4
;variable       51lnox2dFLOAT           3
;variable       52jo1dFLOAT           4
;variable       53jnoFLOAT           4
;variable       54cot6hrFLOAT           4
;variable       55emcofireFLOAT           4
;variable       56thetaFLOAT           4
;variable       57sulfFLOAT           4
;variable       58noyFLOAT           4

ncdf_varget,nc_file_id,'grid_yt',lat
ncdf_varget,nc_file_id,'grid_xt',lon
ncdf_varget,nc_file_id,'pdash',p
ncdf_varget,nc_file_id,'zdash',z
ncdf_varget,nc_file_id,'sfcp',psfc
ncdf_varget,nc_file_id,'theta',ttheta
ncdf_varget,nc_file_id,'co',co
;
; map chemical variables to 3d array one at a time
;
    d4d=fltarr(nlon,nlat,nlev,nchem)
;    dummy=fltarr(nlon,nlat,nlev)
    for k=0,nchem-1L do begin
print,cname(k)
      if cname(k) ne 'ext_cld6hr' then ncdf_varget,nc_file_id,cname(k),dummy
;      if k eq 0 then dummy=dummy*28.964/18.0153  ;mw dry air/mw h2o
      if cname(k) eq 'oxften' then begin
        ncdf_varget,nc_file_id,'oxdten',dummy2
        dummy = dummy-dummy2
        dummy2 = 0.
        ncdf_varget,nc_file_id,'o3dep',dummy2
        dummy(*,*,nlev-1) = dummy(*,*,nlev-1)+dummy2
        dummy2 = 0.
      endif
      if cname(k) eq 'ext_cld6hr' then begin
        ncdf_varget,nc_file_id,'cot6hr',dummy
        dummy=dummy/delz
      endif
      d4d(*,*,*,k)=dummy
    endfor
    ncdf_varget,nc_file_id,'sfcz',zsfc
;
; close netCDF file
;
    ncdf_close,nc_file_id
;
    ; d4d is stored (lons,lats,levs,species) 

    for ilr=0,1 do begin
     if ilr eq 0 then begin
      count=nleft
      index=left
      print,'# points earlier than current uwhyb output file',count
     endif else begin
      count=nright
      index=right
      print,'# points later than current uwhyb output file',count
     endelse
     if count gt 0 then begin
      for nn=0l,count-1l do begin
        n=index(nn)
        i=isave(n)
        ip1=(i+1) mod nc   ;account for wrap longitude
        j=jsave(n)
        xfac=xfsave(n)
        yfac=yfsave(n)
        if i ne -999 and j ne -999 then begin
          facij=(1.-xfac)*(1.-yfac)
          facijp1=(1.-xfac)*yfac
          facip1j=xfac*(1.-yfac)
          facip1jp1=xfac*yfac
          if ilr eq 0 then $
           tfac=(sco(n)-uwhyb_time(itime-1))/ $
                (uwhyb_time(itime)-uwhyb_time(itime-1)) $
          else $
           tfac=(uwhyb_time(itime+1)-sco(n))/ $
                (uwhyb_time(itime+1)-uwhyb_time(itime))
          ;print,'time factor= ',tfac
          for k=0,nchem-1 do begin
            for l=0,nlev-1 do begin
              colp=facij*  d4d(i,j,l,k)     + facijp1*  d4d(i,j+1,l,k)+ $
                   facip1j*d4d(ip1,j,l,k)   + facip1jp1*d4d(ip1,j+1,l,k)
              curtain(k,l,n)=curtain(k,l,n)+tfac*colp
              if k eq 0 then begin
                colp=facij*  p(i,j,l)     + facijp1*  p(i,j+1,l)+ $
                   facip1j*p(ip1,j,l)   + facip1jp1*p(ip1,j+1,l)
                pcurt(l,n)=pcurt(l,n)+tfac*colp
                colp=facij*  z(i,j,l)     + facijp1*  z(i,j+1,l)+ $
                   facip1j*z(ip1,j,l)   + facip1jp1*z(ip1,j+1,l)
                zcurt(l,n)=zcurt(l,n)+tfac*colp
                colp=facij* ttheta(i,j,l)     + facijp1* ttheta(i,j+1,l)+ $
                    facip1j*ttheta(ip1,j,l)   + facip1jp1*ttheta(ip1,j+1,l)
                thcurt(l,n)=thcurt(l,n)+tfac*colp
              endif
            endfor
          endfor
;
; get model surface pressure
;
              colp=facij* psfc(i,j)     + facijp1* psfc(i,j+1)+ $
                    facip1j*psfc(ip1,j)   + facip1jp1*psfc(ip1,j+1)
              psfc_mod(n)=psfc_mod(n)+tfac*colp
              colp=facij* zsfc(i,j)     + facijp1* zsfc(i,j+1)+ $
                    facip1j*zsfc(ip1,j)   + facip1jp1*zsfc(ip1,j+1)
              zsfc_mod(n)=zsfc_mod(n)+tfac*colp
        endif
      endfor
     endif
    endfor
    ;Save space
    print,' '
    d4d=0.
    uu=0.
    vv=0.
    ttheta=0.
  endfor
  ofile=curtain_dir+ofiles(nf)+'_curtain_with_extinction_C192.v8.9.mollweide.vertmix.plumerise.scale.aware.sas.flux.limited.regrid.dat'
  close,20
  openw,20,ofile,/f77
  writeu,20,nchem,nl,itotal
;  writeu,20,sco
  writeu,20,utcsec
  writeu,20,xco
  writeu,20,yco
  writeu,20,psfc_mod
  writeu,20,zsfc_mod
  writeu,20,pcurt
  writeu,20,zcurt
  writeu,20,curtain
  writeu,20,thcurt

  close,20
;Save space
  curtain=0.
  pcurt=0.
  thcurt=0.
endfor  ;flight loop

end
