common exchange,varname
common passin,time,lons,lats
@getpos

set_plot,'ps'
setplot=' '
read,'setplot? ',setplot
npanels=12
;for ipan=0,npanels-1 do begin
for ipan=3,3 do begin
if ipan eq 0 then begin
model_species='SO4'
scale=1e12
unit='(pptv)'
      lev=1000.*findgen(31)/30.
endif
if ipan eq 1 then begin
model_species='Dust'
scale=1e9
unit='(nano-gram/gram)'
      lev=200.*findgen(31)/30.
endif
if ipan eq 2 then begin
model_species='BCOC'
scale=1e9
unit='(ppbv)'
      lev=20.*findgen(31)/30.
endif
if ipan eq 3 then begin
model_species='ext_cld6hr'
scale=1000.
unit='[km!U-1!N]'
      lev=.5*findgen(31)/30.
endif
if ipan eq 4 then begin
model_species='WV'
scale=1000.
unit='(Water Vapor)'
      lev=5.*findgen(31)/30.
endif
if ipan eq 5 then begin
model_species='V'
scale=1.
unit='(Meridional Wind)'
      lev=-30+2.*findgen(31)
endif
if ipan eq 6 then begin
model_species='Extinction_SO4'
scale=1000.
unit='[km!U-1!N]'
      lev=.1*findgen(31)/30.
endif
if ipan eq 7 then begin
model_species='Extinction_Dust'
scale=1000.
unit='[km!U-1!N]'
      lev=.1*findgen(31)/30.
endif
if ipan eq 8 then begin
model_species='Extinction_SeaSalt'
scale=1000.
unit='[km!U-1!N]'
      lev=.1*findgen(31)/30.
endif
if ipan eq 9 then begin
model_species='Extinction_BCOC'
scale=1000.
unit='[km!U-1!N]'
      lev=.1*findgen(31)/30.
endif
if ipan eq 10 then begin
model_species='Extinction_Total'
scale=1000.
unit='[km!U-1!N]'
      lev=.5*findgen(31)/30.
endif
if ipan eq 11 then begin
model_species='Relative_Humidity'
scale=1.
unit='[%]'
      lev=100.*findgen(31)/30.
endif

; AK Local
hrmin=22
mnmin=23
scmin=00
;
hrmin=00
mnmin=00
scmin=00

minlab=strtrim(hrmin,2)+':'+strtrim(mnmin,2)+':'+strtrim(scmin,2)+'Z'
gmtmin=hrmin+mnmin/60.+scmin/(60.*60.)
; AK Local
hrmax=22
mnmax=27
scmax=00
;
hrmax=48
mnmax=60
scmax=50

maxlab=strtrim(hrmax,2)+':'+strtrim(mnmax,2)+':'+strtrim(scmax,2)+'Z'
pslab='h'+strtrim(hrmin,2)+'m'+strtrim(mnmin,2)+'s'+strtrim(scmin,2)+'Z-h'+$
strtrim(hrmax,2)+'m'+strtrim(mnmax,2)+'s'+strtrim(scmax,2)+'Z'
gmtmax=hrmax+mnmax/60.+scmin/(60.*60.)

;--------------------------------------------------
;
; Define dates, datfilprefix, and species
;
;  everything else will be defined below based on these
;
;--------------------------------------------------

datdir='/iliad/proxy/bpierce/Satellite/CALIPSO/'

head='CALIPSO Data'

close,1
openr,1,'calipso.July.22.2019.fil'
nfiles=0
readf,1,nfiles
ofiles=strarr(nfiles)
datfil=strarr(nfiles)
dates=strarr(nfiles)
for nf=0,nfiles-1 do begin
blank=''
readf,1,blank
datfil(nf)=blank
result=str_sep(blank,'.')
label=result(0)+'.'+result(1)
ofiles(nf)=label+'_r1_curtain'
dates(nf)=result(1)
endfor

nfiles=n_elements(datfil)

flt_dir='/ships19/aqda/bpierce/FIREX-AQ/'
moddir='FV3GFS_CALIPSO/'
mod_suff='_with_extinction_C192.v8.9.mollweide.vertmix.plumerise.scale.aware.sas.flux.limited.regrid'

; set color table
  loadct,45,file='./From_chieko/color_ck.tbl'
  !p.background=254.
  !p.color=255.
mcolor=byte(!p.color)
mcolor=fix(mcolor)
if mcolor eq 0 then mcolor=255
col1=mcolor
icmm1=mcolor-1
icmm2=mcolor-2
if setplot eq 'x' then begin
   lc=mcolor
   window,4,xsize=nxdim,ysize=nydim
   device,retain=2,decomposed=0
endif

setymin=999
setymax=-999

ylog=0
!p.multi=0
cs=0.5
cs=1.0

for nf=0,nfiles-1 do begin
;--------------------------------------------------

  ; READ MODEL CURTAIN FILE
  filen=ofiles(nf)
  print,filen
  if setplot eq 'ps' then begin
   set_plot,'ps'
   nxdim=1500
   nydim=750
   xsize=nxdim/100.
   ysize=nydim/100.
   device,/inch,/portrait,xoff=4.25-xsize/2.,yoff=5.5-ysize/2.,$
    xsize=xsize,ysize=ysize
     device,/color
   device,filename='./Plots/FV3GFS_obs_'+dates(nf)+'_'+model_species+mod_suff+'.global.track.ps'
     !psym=0
     !p.font=0
     device,font_size=9
     !p.thick=2.0                   ;Plotted lines twice as thick
  endif
  filen=filen+mod_suff+'.dat'
  ifile=flt_dir+moddir+filen
  close,20
  openr,20,ifile,/f77
  nspec=0L
  nl=0L
  ntime=0L
  readu,20,nspec,nl,ntime
  time=dblarr(ntime)
  lons=fltarr(ntime)
  lats=fltarr(ntime)
  psfc=fltarr(ntime)
  zsfc=fltarr(ntime)
  pgrid=fltarr(nl,ntime)
  curtain=fltarr(nspec,nl,ntime)
  thcurt=fltarr(nl,ntime)
  zcurt=fltarr(nl,ntime)
  readu,20,time
  readu,20,lons
  readu,20,lats
  readu,20,psfc
  readu,20,zsfc
  readu,20,pgrid
  readu,20,zcurt
  readu,20,curtain
  readu,20,thcurt
  close,20
print,max(time),min(time)
;openw,1,'DC8_july_18_2004.dat'
;printf,1,ntime
;for kl=0l,ntime-1l do begin
;xdum=lons(kl)
;ydum=lats(kl)
;tdum=time(kl)
;printf,1,tdum,xdum,ydum
;endfor
  check=where(lons gt 180,cc)
  if cc gt 0 then lons(check)=lons(check)-360.
;-------------------------------------------------------------------------
; Read in CALIPSO Extinction data
;-------------------------------------------------------------------------

filename=datdir+datfil(nf)
sds_name_APro='Extinction_Coefficient_532'

err=0
err=HDF_OPEN(filename)
if err le 0 then goto,jump_to_end
vdata_ref=-1
vdata_ref=HDF_VD_GETID(err,vdata_ref)
vdata_id=HDF_VD_ATTACH(err,vdata_ref,/READ)
result=HDF_VD_READ(vdata_id,Altitude,fields="Lidar_Data_Altitudes")
if result eq 0 then stop, result

FileID=HDF_SD_START(filename,/READ)

index=HDF_SD_NAMETOINDEX(FileID, SDS_NAME_APro)
if index[0] eq -1 then goto,skip_data

; Select the Gridded Data SDS
thisSDSID=HDF_SD_SELECT(FileID, index)
HDF_SD_GETDATA,thisSdsID,data
skip_data:
; Find the index of the 'Profile_UTC_Time' SDS.
index=HDF_SD_NAMETOINDEX(FileID, "Profile_UTC_Time")
thisSDSID=HDF_SD_SELECT(FileID, index)
HDF_SD_GETDATA,thisSdsID,Profile_Time
print,'time: ',max(time),min(time)
; Find the index of the 'Longitude' SDS.
index=HDF_SD_NAMETOINDEX(FileID, "Longitude")

if index[0] eq -1 then goto,jump_to_end

; Select the Gridded Data SDS
thisSDSID=HDF_SD_SELECT(FileID, index)
HDF_SD_GETDATA,thisSdsID,Longitude
print,'lon: ',max(longitude),min(longitude)
if index[0] eq -1 then goto,jump_to_end

; Find the index of the 'Latitude' SDS.
index=HDF_SD_NAMETOINDEX(FileID, "Latitude")

; Select the Latitude SDS
thisSDSID=HDF_SD_SELECT(FileID, index)
HDF_SD_GETDATA,thisSdsID,Latitude
print,'lat: ',max(latitude),min(latitude)


HDF_SD_ENDACCESS,thisSdsID
HDF_SD_END,FileID


jump_to_end:
;time=reform(time(1,*))
longitude=reform(longitude(1,*))
latitude=reform(latitude(1,*))
nvalues=n_elements(time)
utcsec=time
index=where(utcsec-shift(utcsec,-1) gt 0.)
if n_elements(index) gt 1 then utcsec(index(0)+1:nvalues-1)=utcsec(index(0)+1:nvalues-1)+24.*60.*60.
Lat=latitude
Lon=longitude

;stop
;Extract model curtain and flight-track data
  timplt=fltarr(nl,ntime)
  for l=0,nl-1 do timplt(l,*)=utcsec
  zcurt=transpose(zcurt)/1000.
  timplt=transpose(timplt)
;     'co','noy','o3vmr',$
;       0     1      2
;     'ext_cld6hr','emcofire',$
;       3          4
;     'bc1','bc2','oc1','oc2','sulf',$
;       5     6     7     8     9
;     'dust1','dust2','dust3','dust4','dust5',$
;       10      11      12      13      14
;     'seas1','seas2','seas3','seas4','seas5',$
;       15      16      17      18      19
;'ext_sulf',$
;       20
;'ext_dust',$
;       21
;'ext_seas',$
;       22
;'ext_bcoc',$
;       23
;'ext_tot'$
;       24
case 1 of
    model_species eq 'SO4':begin
      sindex=9
      modcurt=reform(curtain(sindex,*,*))
    end
    model_species eq 'Dust':begin
      sindex=10
      modcurt=reform(curtain(sindex,*,*))
      sindex=11
      modcurt=modcurt+reform(curtain(sindex,*,*))
      sindex=12
      modcurt=modcurt+reform(curtain(sindex,*,*))
      sindex=13
      modcurt=modcurt+reform(curtain(sindex,*,*))
      sindex=14
      modcurt=modcurt+reform(curtain(sindex,*,*))
    end
    model_species eq 'SeaSalt':begin
      sindex=15
      modcurt=reform(curtain(sindex,*,*))
      sindex=16
      modcurt=modcurt+reform(curtain(sindex,*,*))
      sindex=17
      modcurt=modcurt+reform(curtain(sindex,*,*))
      sindex=18
      modcurt=modcurt+reform(curtain(sindex,*,*))
      sindex=19
      modcurt=modcurt+reform(curtain(sindex,*,*))
    end

    model_species eq 'BCOC':begin
      sindex=5
      modcurt=reform(curtain(sindex,*,*))
      sindex=6
      modcurt=modcurt+reform(curtain(sindex,*,*))
      sindex=7
      modcurt=modcurt+reform(curtain(sindex,*,*))
      sindex=8
      modcurt=modcurt+reform(curtain(sindex,*,*))
    end

    model_species eq 'ext_cld6hr':begin
      sindex=3
      modcurt=reform(curtain(sindex,*,*))
    end
    model_species eq 'Extinction_SO4':begin
      sindex=20
      modcurt=reform(curtain(sindex,*,*))
print,'EXT SO4 ',max(modcurt)
    end
    model_species eq 'Extinction_Dust':begin
      sindex=21
      modcurt=reform(curtain(sindex,*,*))
print,'EXT Dust ',max(modcurt)
    end
    model_species eq 'Extinction_SeaSalt':begin
      sindex=22
      modcurt=reform(curtain(sindex,*,*))
print,'EXT SS ',max(modcurt)
    end
    model_species eq 'Extinction_BCOC':begin
      sindex=23
      modcurt=reform(curtain(sindex,*,*))
print,'EXT BCOC ',max(modcurt)
    end
    model_species eq 'Extinction_Total':begin
      sindex=24
      modcurt=reform(curtain(sindex,*,*))
print,'EXT TOT ',max(modcurt)
    end
    else: stop,'model species not defined, '+model_species
  endcase
  modcurt=scale*transpose(modcurt)
 thcurt=reform(thcurt(*,*))
  thcurt=transpose(thcurt)
;PLOT CURTAIN
;
lab=1+intarr(30)
color=1+(mcolor-2)*findgen(31)/30.
xmn=min(timplt)
xmx=max(timplt)
set_viewport,.1,.7,.2,.8
plot,timplt,zcurt,/nodata,xrange=[xmn,xmx],yrange=[0.,15.], $
 xstyle=1,ystyle=1,xthick=2,ythick=2, $
 xtickunits=['Numeric','Numeric','Numeric'],xtickformat='xticks3',$
 ytitle='Altitude (m)',ymargin=[8,2], $
 title='FV3GFS '+mod_suff+' '+model_species+' '+unit+' '+dates(nf)

contour,modcurt,timplt,zcurt,levels=lev,/cell_fill,c_colors=color,/overplot
!linetype=1
contour,thcurt,timplt,zcurt,levels=260.+5.*findgen(31),c_label=lab,c_charsize=cs, $
/overplot,color=mcolor
!linetype=0
xpos=xmn-.08*(xmx-xmn)
xyouts,xpos,0,'UTC Sec'
xyouts,xpos,-1,'Lon'
xyouts,xpos,-2,'Lat'
today=systime(0)
xyouts,.8,.005,today,/normal
;
; draw map
;
set_viewport,.7,.9,.5,.9
map_set,0,-180,0,/continents,/us,limit=[-90,-180,90,180],/noeras
map_grid,dlon=5,dlat=5
oplot,lon,lat
; color bar
        !psym=0
        imin=min(lev)
        imax=max(lev)
        set_viewport,.2,.8,.05,.07
        !type=2^2+2^3+2^6
        plot,[imin,imax],[0,0],yrange=[0,10],xrange=[imin,imax],$
        xtitle=unit,/noeras
        ybox=[0,10,10,0,0]
        x2=imin
        dx=(imax-imin)/float(icmm2)
        for j=0,icmm2 do begin
            xbox=[x2,x2,x2+dx,x2+dx,x2]
            polyfill,xbox,ybox,color=j
            x2=x2+dx
        endfor

if setplot ne 'ps' then stop
endfor
endfor

if setplot eq 'ps' then device,/close
end
